/* --------------------------------------------------------------------------------------------------------------------
                                            CURSO DE PROGRAMAO EM PL-SQL
                                                  PEDRO F. CARVALHO
                                              www.pedrofcarvalho.com.br
                                            contato@pedrofcarvalho.com.br
                                              ORACLE 9i, 10G, 11G E 12C
                         Preparao para a prova 1Z0-147 e 1Z0-144 e 1Z0-146 Program with PL/SQL  
----------------------------------------------------------------------------------------------------------------------*/


Captulo 03 - Usando SQL Function em PL-SQL.

Sql Functions
Converses implicitas e explicitas no Oracle
Identao de cdigos
Criando DML dentro de blocos PL-SQL
Usar a clausula into para retornar valores

A primeira (e mais simples) regra para melhorar a performance  minimizar as converses de datatypes no Oracle.
Para quem no se lembra, ou nunca reparou, o Oracle PL/SQL faz algumas converses implcitas de seus datatypes, 
veja um exemplo:

DECLARE
 texto CHAR(5);
BEGIN
 texto := 25;
END;

Veja que no exemplo acima atribumos um inteiro para uma varivel do tipo caracter e o Oracle fez implicitamente a 
converso do datatype do valor enviado pela rotina PL/SQL, isso resume o processo de desenvolvimento 
e at mesmo deixaria o cdigo-fonte PL/SQL mais limpo, porm isso  uma m prtica quando falamos de performance, 
pois o ideal  o seguinte:

DECLARE
 texto CHAR(5);
BEGIN
 texto := '25';
END;

E isso ocorre para qualquer tipo de converso de datatype implcita ou explcita no Oracle PL/SQL

-- Identao, clausula into, insert, update, e delete dentro de bloco PLSQL

-- Select
SET SERVEROUTPUT ON
DECLARE
    V_SOMA  NUMBER(10,2);
    V_FNAME HR.EMPLOYEES.FIRST_NAME%TYPE;
    V_LNAME HR.EMPLOYEES.LAST_NAME%TYPE;
BEGIN
    SELECT  SUM(NVL(SALARY,0)) INTO V_SOMA -- SOMENTE PODE TRAZER UMA LINHA DE REGISTRO
    FROM    HR.EMPLOYEES
    WHERE   DEPARTMENT_ID=10;
    DBMS_OUTPUT.PUT_LINE('A soma  e: ' ||  V_SOMA); 
    
    SELECT  FIRST_NAME, LAST_NAME INTO V_FNAME, V_LNAME
    FROM    HR.EMPLOYEES
    WHERE   EMPLOYEE_ID = 100;
    DBMS_OUTPUT.PUT_LINE('O nome e: ' ||  V_FNAME || ' ' || V_LNAME); 
END;

-- INSERT
DECLARE
BEGIN
    INSERT INTO HR.EMPLOYEES 
        (EMPLOYEE_ID, FIRST_NAME, LAST_NAME, EMAIL, HIRE_DATE, JOB_ID, SALARY)
    VALUES  
        (HR.EMPLOYEES_SEQ.NEXTVAL, 'Pedro', 'Carvalho', 'pedrofcarvalh8@gmail.com', SYSDATE, 'IT_PROG', 5000);  
  COMMIT;
END;

SELECT * FROM HR.EMPLOYEES
WHERE FIRST_NAME = 'Pedro'

-- update
DECLARE
BEGIN
    UPDATE  HR.EMPLOYEES 
    SET     SALARY = 15000
    WHERE   FIRST_NAME = 'Pedro'
    AND     LAST_NAME = 'Carvalho';
    
    COMMIT;
END;

SELECT * FROM HR.EMPLOYEES
WHERE FIRST_NAME = 'Pedro'

-- delete
DECLARE
  v_empid NUMBER;
BEGIN
    SELECT HR.EMPLOYEES_SEQ.CURRVAL INTO V_EMPID  -- posso usar mais variveis
    FROM DUAL; -- porque o dual 
    if v_empid <> 0 then
      DELETE FROM HR.EMPLOYEES
      WHERE  EMPLOYEE_ID = v_empid;  
      COMMIT;
    end if;   
END;

SELECT * FROM HR.EMPLOYEES
WHERE FIRST_NAME = 'Pedro'

No PL/SQL Developer tem um plugin chamdo PL/SQL Beutifier, que faz exatamente isso.  possivel at escolher vrias 
coisas, como colocar vrugla ANTES ou DEPOIS dos campos, colocar o THEN em uma nova linha ou na mesma linha do IF, 
etc...

Funes mais utilizadas em SQL

A linguagem SQL possui muitas funes prontas para efetuar clculos nos dados armazenados.

Outras Funes

ABS(n)= Devolve o valor absoluto de (n). 
CEIL(n)=Obtm o valor inteiro imediatamente superior ou igual a "n". 
FLOOT(n) = Devolve o valor inteiro imediatamente inferior ou igual a "n". 
MOD (m, n)= Devolve o resto resultante de dividir "m" entre "n". 
NVL (valor, expresso)= Substitui um valor nulo por outro valor. 
POWER (m, exponente)= Calcula a potncia de um nmero. 
ROUND (numero [, m])= Arredonda nmeros com o nmero de dgitos de preciso indicados. 
SQRT(n)= Devolve a raiz quadrada de "n". 
TRUNC (numero, [m])= Trunca nmeros para que tenham uma certa quantidade de dgitos de preciso. 
VAIRANCE (valor)= Devolve a mdia de um conjunto de valores. 

Funes de grupos de valores: 

AVG(n)= Calcula o valor mdio de "n" ignorando os valores nulos. 
COUNT (* | Expresso)= Conta o nmero de vezes que a expresso avalia algum dado com valor no nulo. A opo "*" conta 
      todas as filas selecionadas. 
MAX (expresso)= Calcula o mximo. 
MIN (expresso)= Calcula o mnimo. 
SUM (expresso)= Obtm a soma dos valores da expresso. 
GREATEST (valor1, valor2)= Obtm o maior valor da lista. 
LEAST (valor1, valor2)= Obtm o menor valor da lista. 

Funes que devolvem valores de caracteres: 

CHR(n) = Devolve o caractere cujo valor em binrio  equivalente a "n". 
CONCAT (cad1, cad2)= Devolve "cad1" concatenada com "cad2". 
LOWER (cad)= Devolve a cadeia "cad" em minsculas. 
UPPER (cad)= Devolve a cadeia "cad" em maisculas. 
INITCAP (cad)= Converte a cadeia "cad" a tipo ttulo. 
LPAD (cad1, n[,cad2])= Adiciona caracteres  esquerda da cadeia at que tenha uma certa longitude. 
RPAD (cad1, n[,cad2])= Adiciona caracteres  direita at que tenha uma certa longitude. 
LTRIM (cad [,set])= Suprime um conjunto de caracteres  esquerda da cadeia. 
RTRIM (cad [,set])= Suprime um conjunto de caracteres  direita da cadeia. 
REPLACE (cad, cadeia_busca [, cadeia_substitucao])= Substitui um caractere ou caracteres de uma cadeia com 0 ou mais 
        caracteres. 
SUBSTR (cad, m [,n])= Obtm parte de uma cadeia. 
TRANSLATE (cad1, cad2, cad3)= Converte caracteres de uma cadeia em caracteres diferentes, segundo um plano de substituio 
         marcado pelo usurio. 

Funes que devolvem valores numricos: 

ASCII(cad)= Devolve o valor ASCII da primeira letra da cadeia "cad". 
INSTR (cad1, cad2 [, comeco [,m]])= Permite uma busca de um conjunto de caracteres em uma cadeia, mas no suprime 
      nenhum caractere depois. 
LENGTH (cad)= Devolve o nmero de caracteres de cad. 

Funes para o manejo de datas: 

SYSDATE= Devolve a data do sistema. 
ADD_MONTHS (data, n)= Devolve a data "data" incrementada em "n" meses. 
LASTDAY (data)= Devolve a data do ltimo dia do ms que contm "data". 
MONTHS_BETWEEN (data1, data2)= Devolve a diferena em meses entre as datas "data1" e "data2". 
NEXT_DAY (data, cad)= Devolve a data do primeiro dia da semana indicado por "cad" depois da data indicada por "data". 

Funes de converso: 

TO_CHAR= Transforma um tipo DATE ou NUMBER em uma cadeia de caracteres. 
TO_DATE= Transforma um tipo NUMBER ou CHAR em DATE. 
TO_NUMBER= Transforma uma cadeia de caracteres em NUMBER.

Exemplos

-- exemplo de decode
SELECT  DECODE(CITY,'Sao Paulo','SAO PAULO',
                     'London', 'LONDON', 
                     CITY) AS CITY
FROM    HR.LOCATIONS;

-- exemplo de nvl
SELECT  FIRST_NAME || ' ' || LAST_NAME, 
        SALARY + (SALARY * NVL(COMMISSION_PCT ,0)) AS TOTAL_SALARY
FROM    HR.EMPLOYEES;

-- exemplo sem nvl
SELECT  FIRST_NAME || ' ' || LAST_NAME, 
        SALARY + (SALARY * COMMISSION_PCT ) AS TOTAL_SALARY
FROM    HR.EMPLOYEES;

-- exemplo de coalesce
SELECT  COMMISSION_PCT, COALESCE(MAX_COMISSION_PCT, COMMISSION_PCT, 0.1), COALESCE(MAX_COMISSION_PCT, COMMISSION_PCT, 0.1) * SALARY AS VALOR_COMISSAO
FROM    HR.EMPLOYEES
WHERE   DEPARTMENT_ID IN (70, 80);

alter table hr.employees add max_comission_pct number;

SELECT    AVG(SALARY)
FROM      HR.EMPLOYEES
WHERE     DEPARTMENT_ID = 100;

SELECT  MIN(SALARY)
FROM    HR.EMPLOYEES
WHERE   DEPARTMENT_ID = 100;

SELECT  MAX(SALARY)
FROM    HR.EMPLOYEES
WHERE   DEPARTMENT_ID = 100;

SELECT  COUNT(*) -- count(employee_id)  count(commision_pct)
FROM    HR.EMPLOYEES
WHERE   DEPARTMENT_ID = 100;

SELECT  SUM(SALARY)
FROM    HR.EMPLOYEES
WHERE   DEPARTMENT_ID = 100;

SELECT  TO_CHAR(HIRE_DATE, 'dd/mm/yyyy') as hire_date
FROM    HR.EMPLOYEES
WHERE   DEPARTMENT_ID = 100;

SELECT  TO_CHAR(HIRE_DATE, 'dd/mm') as hire_date
FROM    HR.EMPLOYEES
WHERE   DEPARTMENT_ID = 100;

SELECT  TO_DATE('12/25/2012', 'mm/dd/YYYY') 
FROM    DUAL;

SELECT  TO_NUMBER('15.79', '99.99') 
FROM    DUAL;

SELECT  LENGTH('PEDRO CARVALHO') 
FROM    DUAL;

SELECT  UPPER(FIRST_NAME)
FROM    HR.EMPLOYEES;

SELECT  INITCAP(FIRST_NAME)
FROM    HR.EMPLOYEES;

SELECT  FIRST_NAME, REPLACE(FIRST_NAME,'a', 'Z')
FROM    HR.EMPLOYEES;

SELECT  USER 
FROM    DUAL;





