/* --------------------------------------------------------------------------------------------------------------------
                                            CURSO DE PROGRAMAO EM PL-SQL
                                                  PEDRO F. CARVALHO
                                              www.pedrofcarvalho.com.br
                                            contato@pedrofcarvalho.com.br
                                              ORACLE 9i, 10G, 11G E 12C
                         Preparao para a prova 1Z0-147 e 1Z0-144 e 1Z0-146 Program with PL/SQL  
----------------------------------------------------------------------------------------------------------------------*/


Captulo 08 - Usando Procedures.

Uma stored procedure  um bloco de instrues PL/SQL que executa uma ou mais tarefas especficas. Elas so bem similares 
com as procedures de outras linguagens de programao.

Uma procedure normalmente possui um cabealho e um corpo. O cabealho consiste do nome e de parmetros ou variveis que 
sero passadas para a procedure. J o corpo consiste da declarao de uma seo, execuo de uma seo e uma seo de 
excees muito similar a um bloco geral da PL/SQL. Uma procedure pode ou no ter um valor de retorno. Normalmente 
as procedures so criadas dentro de pacotes ou em blocos PL/SQL.

Podemos passar os parmetros para uma procedure de trs maneiras:

Parmetros IN  passamos o valor na prpria procedure.
Parmetros OUT  recebemos o valor a partir da chamada de blocos externos.
Parmetros IN OUT  passamos um valor inicial para a procedure e recebemos de volta uma atualizao.

 possvel definir uma procedure com parametros ou sem parametros.



-- 1: criando a SP HR.SP_EMPREGADO_I
CREATE OR REPLACE PROCEDURE HR.SP_EMPREGADO_I(P_FIRSTNAME VARCHAR2, P_LASTTNAME VARCHAR2, P_EMAIL VARCHAR2,
      P_PHONENUMBER NUMBER, P_HIREDATE DATE, P_JOBID VARCHAR2, P_SALARY NUMBER, 
      P_COMMISSIONPCT NUMBER, P_MANAGERID NUMBER, P_DEPARTMENTID NUMBER)
IS
BEGIN
  INSERT INTO HR.EMPLOYEES (EMPLOYEE_ID, FIRST_NAME, LAST_NAME, EMAIL,
        PHONE_NUMBER, HIRE_DATE, JOB_ID, SALARY, COMMISSION_PCT, MANAGER_ID, DEPARTMENT_ID)
  VALUES (HR.EMPLOYEES_SEQ.NEXTVAL, P_FIRSTNAME, P_LASTTNAME, P_EMAIL,
        P_PHONENUMBER, P_HIREDATE, P_JOBID, P_SALARY, P_COMMISSIONPCT, P_MANAGERID, P_DEPARTMENTID);
  COMMIT;
END;

-- 2: chamando a SP HR.SP_EMPREGADO_I
BEGIN
  -- inserindo novo empregado
  HR.SP_EMPREGADO_I('PEDRO','CARVALHO','pedrofcarvalho.com',73035547,SYSDATE-65,'IT_PROG',5300,NULL,103,60);
END;

-- 3: verificando se a SP executou o seu trabalho
SELECT * FROM HR.EMPLOYEES WHERE FIRST_NAME = 'PEDRO' AND LAST_NAME = 'CARVALHO'

-- 1: criando a SP HR.SP_EMPREGADO_D
CREATE OR REPLACE PROCEDURE HR.SP_EMPREGADO_D(P_EMPLOYEE_ID NUMBER)
IS
BEGIN
  DELETE FROM HR.EMPLOYEES
  WHERE  EMPLOYEE_ID= P_EMPLOYEE_ID;
  COMMIT;
END;

-- 2: chamando a SP HR.SP_EMPREGADO_D
DECLARE
    V_id NUMBER;
BEGIN
  SELECT  EMPLOYEE_ID INTO V_ID
  FROM    HR.EMPLOYEES 
  WHERE   FIRST_NAME = 'PEDRO'
  AND     LAST_NAME = 'CARVALHO';
  -- apagando empregado PEDRO CARVALHO
  HR.SP_EMPREGADO_D(V_id);
END;

-- 3: verificando se a SP executou o seu trabalho
SELECT * FROM HR.EMPLOYEES WHERE FIRST_NAME = 'PEDRO' AND LAST_NAME = 'CARVALHO'

-- 1: criando a SP HR.SP_EMPREGADO_S
CREATE OR REPLACE PROCEDURE HR.SP_EMPREGADO_S(P_CR OUT SYS_REFCURSOR)
IS
BEGIN
  OPEN P_CR FOR
    SELECT FIRST_NAME, LAST_NAME FROM HR.EMPLOYEES;  
END;

-- 2: chamando a SP HR.SP_EMPREGADO_S
SET SERVEROUTPUT ON
DECLARE
  V_CURSOR  SYS_REFCURSOR;
  V_FN   HR.EMPLOYEES.FIRST_NAME%TYPE;
  V_LN   HR.EMPLOYEES.LAST_NAME%TYPE;    
BEGIN
  HR.SP_EMPREGADO_S (V_CURSOR);
            
  LOOP 
    FETCH V_CURSOR INTO V_FN, V_LN;
    EXIT WHEN V_CURSOR%NOTFOUND;
    DBMS_OUTPUT.PUT_LINE(V_FN || ' ' || V_LN);
  END LOOP;
  CLOSE V_CURSOR;
END;

SYS_REFCURSOR  declarado no pacote STANDARD (um dos dois pacotes "default" do PL/SQL) e  uma declarao de um weekly 
typed cursor (cursor com tipo fraco). i.e. IS REF CURSOR


Privilegios de invocador sys_refcursor - alem de dar o provilegio de execute a um usuario deve-se dar os provilegiodsde objetos

-- 1: criando a SP HR.SP_EMPREGADO_S (at Oracle 11G)
CREATE OR REPLACE PROCEDURE HR.SP_EMPREGADO_S(P_CR OUT SYS_REFCURSOR)
AUTHID current_user IS
BEGIN
  OPEN P_CR FOR
    SELECT FIRST_NAME, LAST_NAME FROM HR.EMPLOYEES;
END;

-- criando a SP HR.SP_EMPREGADO_S no Oracle 12c (nao eh necessario declarar o parametro de saida)
CREATE OR REPLACE PROCEDURE HR.SP_EMPLOYEES_S
AUTHID current_user IS
  v_cursor sys_refcursor;
BEGIN
  open v_cursor for 
      SELECT FIRST_NAME, LAST_NAME FROM HR.EMPLOYEES;
      dbms_sql.return_result(v_cursor);
END;

-- Execute a instrucao abaixo no SQL PLus
EXEC HR.SP_EMPLOYEES_S;

-- testar proc 2 conectado primeiro como HR e depois com outro usuario que nao tenha priv de SELECT na tabela HR.EMPLOYEES

-- 2: chamando a SP HR.SP_EMPREGADO_S
SET SERVEROUTPUT ON
DECLARE
  V_CURSOR  SYS_REFCURSOR;
  V_FN   HR.EMPLOYEES.FIRST_NAME%TYPE;
  V_LN   HR.EMPLOYEES.LAST_NAME%TYPE;    
BEGIN
  HR.SP_EMPREGADO_S (V_CURSOR);
            
  LOOP 
    FETCH V_CURSOR INTO V_FN, V_LN;
    EXIT WHEN V_CURSOR%NOTFOUND;
    DBMS_OUTPUT.PUT_LINE(V_FN || ' ' || V_LN);
  END LOOP;
  CLOSE V_CURSOR;
END;



transao autonoma, a procedure que tiver essa clausula ele nao da rollback nela caso acontea  um erro.
se executar-mos as 4 store procedures, 1 ok 2 ok 3 erro 4 ok

-- apos ver isso, retirar acrescentar os pragma e vera de vai dar um erro
-- 1: criando a SP HR.SP_EMPREGADO_D
CREATE OR REPLACE PROCEDURE HR.SP_EMPREGADO_D(P_EMPLOYEE_ID NUMBER)
IS PRAGMA AUTONOMOUS_TRANSACTION;
BEGIN
  DELETE FROM HR.EMPLOYEES
  WHERE  EMPLOYEE_ID= P_EMPLOYEE_ID;  
  ROLLBACK;
END;
/

PRAGMA AUTONOMOUS_TRANSACTION; 

Esta instruo (PRAGMA) funciona como uma diretiva de compilao para o ORACLE, que passa a tratar esta funo como um 
cdigo independente da transao principal que esteja ocorrendo. Assim, o COMMIT realizado na funo, no afeta outras 
transaes abertas. Esse mecanismo tambm possibilitou que o INSERT realizado na tabela temporria por esta funo 
pudesse ser realizado, mesmo que a funo seja executada em uma instruo de SELECT, o que, normalmente,no seria 
permitido pelo Oracle (nestes casos  normal ele levantar a exceo ORA-14551: cannot perform a DML operation 
inside a query).


DROP PROCEDURE HR.SP_EMPREGADO_S;

SELECT  *--OWNER, OBJECT_NAME
FROM    ALL_OBJECTS
WHERE   OBJECT_TYPE = 'PROCEDURE';

SELECT      owner, name, text
FROM        ALL_SOURCE 
WHERE       TYPE='PROCEDURE'
and owner = 'HR'
ORDER BY    1,2,line;

Extra ..

Durante a instalao do banco de dados Oracle um script  executado automaticamente e cria toda a estrutura 
necessria para que as procedures sejam executadas. Eventualmente esse procedimento automtico pode falhar devido 
a alguma falha fsica no disco rgido, nesse caso o usurio SYS pode recriar a estrutura atravs do script 
SQL DBMSSTDX.SQL.




