/* --------------------------------------------------------------------------------------------------------------------
                                            CURSO DE PROGRAMAO EM PL-SQL
                                                  PEDRO F. CARVALHO
                                              www.pedrofcarvalho.com.br
                                            contato@pedrofcarvalho.com.br
                                              ORACLE 9i, 10G, 11G E 12C
                         Preparao para a prova 1Z0-147 e 1Z0-144 e 1Z0-146 Program with PL/SQL  
----------------------------------------------------------------------------------------------------------------------*/

Capitulo 13 - UTL_MAIL - NOCOPY - DETERMINISTC - PARALELL ENABLE - Hints - Bulk Binding Returning


Para enviar e-mails a partir de um SGBD Oracle, comumente utilizamos as packages UTL_MAIL e UTL_SMTP, mas  possvel 
utilizar tambm a package UTL_TCP. Todas elas foram desenvolvidas pela prpria Oracle e algumas precisam de instalao 
adicional. A UTL_SMTP  mais antiga, existe desde o Oracle 8i e j vem instalada, por padro no BD. A UTL_MAIL est 
disponvel a partir do Oracle 10GR2,  e nada mais  do que um wrapper que utiliza as packages UTL_SMTP e UTL_TCP. 
Ela foi criada para facilitar o envio de e-mails, mas infelizmente, ela possui algumas restries.

Utilizar a package UTL_SMTP para mandar e-mail  bastante complexo e trabalhoso.  bem mais fcil e mais rpido utilizar
a package UTL_MAIL, mas ela possui algumas restries. 

 Explicarei abaixo como usar a UTL_MAIL, por ser a opo mais simples e atualmente a mais utilizada. Para utiliz-la  
 necessrio cumprir alguns pr-requisitos:

1- Instalar a package executando os scripts: $ORACLE_HOME/rdbms/admin/utlmail.sql e $ORACLE_HOME/rdbms/admin/prvtmail.plb. 
A instalao deve ser efetuada por um usurio que tenha privilgios de DBA;
  
2-  Configurar o parmetro de sistema SMTP_OUT_SERVER, com um valor contendo o nome ou IP + porta de um servidor SMTP 
vlido. Se voc omitir o endereo da porta, ser utilizada como padro, a porta 25.  importante salientar que a 
mquina host do BD tenha comunicao com o servidor SMTP, e  tambm, autorizao para enviar mensagens 
(no software do servidor SMTP no deve existir regras que bloqueiem mensagens da mquina host do BD).
Ex.: ALTER SYSTEM SET smtp_out_server = 'smtp.hospitaldebase.com.br.com.br:25';

Obs.: Para executar o comando acima  necessrio ter privilgios de DBA.

3- O remetente (sender) do e-mail deve ser uma conta de e-mail que no requer autenticao para envio de mensagens.

Aps cumprir os pr-requisitos acima, voc j poder utilizar a package UTL_MAIL. Segue abaixo, um bloco PL/SQL 
simples, que contm comentrios sobre o que deve ser passado como valor em cada parmetro, e que pode ser utilizado 
para enviar um e-mail sem anexo, utilizando a procedure SEND desta package:

BEGIN
      UTL_MAIL.SEND
           (SENDER => 'pedrofcarvalho8@gmail.com', -- remetente da mensagem
              RECIPIENTS => 'contato@pedrofcarvalho.com.br',  -- destinatrio da mensagem
              CC => null,  -- destinatrio copiado na mensagem
              BCC => null,  -- destinatrio com cpia oculta da  mensagem
              SUBJECT =>  'Teste de envio de email UTL_MAIL', -- assunto da mensagem
              MESSAGE => 'Ola', -- mensagem do e-mail
              MIME_TYPE => 'text/plain; charset=iso-8859-1'); -- mime type + character set do texto da mensagem
END;

Mensagems com anexo acima de 32k pode dar problemas de envio e podem ter caracteres desconfigurados.
Para evitar estes caracteres desconfigurados  necessrio passar o valor adequado para os parmetros MIME_TYPE, 
que indicam o tipo de aplicao e o conjunto de caracteres que ser utilizado para compor o texto da mensagem ou do 
anexo . Eu normalmente configuro o valor  'text/plain; charset=iso-8859-1' e isso j  suficiente para resolver 
os meus problemas.

--  maiores informaes
https://docs.oracle.com/cd/B28359_01/appdev.111/b28419/u_mail.htm#BABFJJBD

-- NOCOPY

Normalmente, uma varivel passada como parmetro para uma procedure, ela  copiada em uma nova varivel, que  utilizada 
dentro de sua procedure. 
A hint NOCOPY indica que a varivel no deve ser copiada quando a procedure for chamada, utilizando a prpria varivel 
que foi utilizada como argumento da funo diretamente. 

Quando utilizar
Warning(5,2): PLW-07203: o parmetro 'x_exemplo' pode se beneficiar do uso da hint do compilador NOCOPY
Este provavelmente  um alerta gerado pelo seu compilador, indicando que existe alguma vantagem em utilizar o NOCOPY em 
um parmetro do tipo OUT / IN OUT.

As principais vantagens em se utiliziar esta hint seriam para diminuir o tempo de chamada de sua procedure / function 
e tambm o consumo de memria (embora voc no dever notar diferena alguma a no ser que esta procedure seja chamada
milhares de vezes em um perodo muito curto...) , especialmente se o argumento OUT / IN OUT for do tipo LONG / LOB / 
CLOB ou BLOB. 


Teste

CREATE OR REPLACE FUNCTION hr.add_x_y (p_x IN NUMBER, p_y IN NUMBER, p_result IN OUT NOCOPY NUMBER)
RETURN NUMBER
IS
BEGIN
    p_result := p_x + p_y;
RETURN 1;
END;

execute hr.add_x_y(1,1,p_result);

Condies que  ignorado o NOCOPY
1  The actual parameter is a table of the index component
2  The actual parameter is marked as NOT NULL in a constrainted
3  The actual parameter of type% ROWTYPE or% TYPE consists of records is defined in
4  Implicit conversion of a data type, if necessary
5  External or Remote procedure call is


-- Function Clausule Deterministc and Parallel Enable

Clusula DETERMINISTIC

Especifique DETERMINISTIC para indicar que a funo retorna o mesmo valor de resultado sempre que for chamado com 
os mesmos valores para os seus argumentos.

FUNCTION deterministic--(;...)
    RETURN t_out_tab PIPELINED DETERMINISTIC
  IS
    l_row  t_out_row;
  BEGIN
    FOR i IN 1 .. 100 LOOP
      l_row.id := i;
      PIPE ROW (l_row);
    END LOOP;
    RETURN;
END deterministic;



PARALLEL_ENABLE  uma dica de otimizao indicando que a funo pode ser executada a partir de um servidor de execuo 
paralela de uma operao de consulta paralela. A funo no deve usar o estado da sesso, como variveis de pacote, 
como essas variveis no so necessariamente compartilhadas entre os servidores de execuo paralela.

create or replace function mitest return varchar parallel_enable
is
  v_id number:=0;
begin
  select sid into v_id from v$mystat where rownum=1;
  return to_char(v_id);
end;

-- Hints -- curso de tuning de sql

Hints so utilizadas para influenciar o otimizador baseado em custo para controlar os mtodos de acesso e condies de 
junes etc.

- first_rows: Para forar o uso de ndice de modo geral. Faz com que o otimizador escolha um caminho que apanha a
1 linha ou N linhas mais rapidamente.

SQL> select /*+ first_rows (100) */ coluna_1, coluna_2  from nome_tabela;


--  Bulk Binding Returning

O uso do Bulk Collect  aplicado para a manipulao de grande massa de dados. Com seu uso correto, podemos ter vrios 
tipos de ganhos, como por exemplo: Aplicaes mais rpidas, alocao dos dados na memria, sem a necessidade de refazer 
a busca no banco. Mas como todo ganho, temos um risco tambm, pois se no aplicarmos corretamente as diretrizes na 
PGA(Program Global Area), podemos ter problemas na quantidade de dados carregados na memria.

A clusula de returning  usado para retornar colunas especficas de linhas manipulados pelo DML. 
Quando DML manipular vrias linhas, os dados retornados podem ser carregados em um conjunto utilizando 
uma operao em massa. 

SET SERVEROUTPUT ON
DECLARE
  TYPE t_object_id_tab IS TABLE OF bulk_collect_test.object_id%TYPE;
  l_tab  t_object_id_tab;
BEGIN
  DELETE FROM bulk_collect_test
  RETURNING object_id BULK COLLECT INTO l_tab;
  DBMS_OUTPUT.put_line('Deleted IDs : ' || l_tab.count || ' rows');
  ROLLBACK;
END;

Deleted IDs : 61202 rows










